﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TBmemo
{
    public partial class SearchDialogBox : Form
    {
        TextBox _mainText;
        Form1.SearRepMode mode;
        int searchIndex;

        public TextBox mainText{
            get{ return _mainText;}
            set{ _mainText = value;}
        }
        

        public SearchDialogBox(Form1.SearRepMode srMode, TextBox text)
        {
            InitializeComponent();
            mainText = text;
            mode = srMode;
            searchIndex = mainText.SelectionStart;
            if (srMode == Form1.SearRepMode.Search)
            {
                panel1.Visible = false;
                this.Size = new Size(538, 154);
            }
            else
                ReplaceInitializeComponent();
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            if (textBox1.Text != "")
            {
                button1.Enabled = true;
                button3.Enabled = true;
                button4.Enabled = true;
            }
            else
            {
                button1.Enabled = false;
                button3.Enabled = false;
                button4.Enabled = false;
            }
            
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void SearchText(string str)
        {
            int findTextIndex;

            if (checkBox1.Checked)
            {
                if (radioButton1.Checked)
                    findTextIndex = mainText.Text.LastIndexOf(str, searchIndex);
                else
                    findTextIndex = mainText.Text.IndexOf(str, searchIndex);
            }
            else
            {
                if (radioButton1.Checked)
                    findTextIndex = mainText.Text.LastIndexOf(str, searchIndex,StringComparison.CurrentCultureIgnoreCase);
                else
                    findTextIndex = mainText.Text.IndexOf(str, searchIndex,StringComparison.CurrentCultureIgnoreCase);
            }


                if (findTextIndex == -1)
                {
                    MessageBox.Show("指定した文字列が見つかりませんでした", "TBmemo", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }

            mainText.Select(findTextIndex,str.Length);
            mainText.ScrollToCaret();

            if (radioButton1.Checked)
                searchIndex = findTextIndex - 1;
            else
                searchIndex = findTextIndex + str.Length;            

        }

        private void button1_Click(object sender, EventArgs e)
        {
            SearchText(textBox1.Text);
        }

        private void SearchDialogBox_Activated(object sender, EventArgs e)
        {
            searchIndex = mainText.SelectionStart;
        }        

        private void ReplaceInitializeComponent()
        {
            button2.Location = new Point(411, 95);
            groupBox1.Location = new Point(225, 95);
            checkBox1.Location = new Point(14, 90);
            label2.Location = new Point(14, 115);
            numericUpDown1.Location = new Point(66, 115);
            this.Text = "置換";            
        }

        

        

        
    }
}
